/* Code generated by Engee
 * Model name: esp8266_smart_socket.engee
 * Code generator: release-1.1.0
 * Date: Fri Jul 12 13:32:15 2024
 */

#include "stdint.h"
#include "math.h"
#include "esp8266_smart_socket.h"

static struct {
	double ActionPort;                     /* /SET_HIGH/Action Port */
} SET_HIGH_1_U;

static struct {
	bool HIGH_LEV;                         /* /SET_HIGH/HIGH_LEV */
} SET_HIGH_1_Y;

static struct {
	bool UnitDelay_state;                  /* /SET_HIGH/Unit Delay */
} SET_HIGH_1_S;

/* Block states */
Ext_esp8266_smart_socket_S esp8266_smart_socket_S;

typedef struct NTP_Client_cfunc_symbols_t {
	int16_t Hours;
	int16_t Minutes;
	int16_t Seconds;
} NTP_Client_cfunc_symbols_t;

typedef struct NTP_Client_cfunc_params_t {
	bool _;
} NTP_Client_cfunc_params_t;

NTP_Client_cfunc_params_t NTP_Client_cfunc_params = {
	false
};

static void NTP_Client_cfunc_init() {
	#ifdef ESP8266
	    timeClient.begin();  // Инициализация NTP-сервера
	#endif
}
static void NTP_Client_cfunc(NTP_Client_cfunc_symbols_t * cfunc_symbols, NTP_Client_cfunc_params_t * cfunc_params) {
	int16_t Hours;
	int16_t Minutes;
	int16_t Seconds;
	#ifdef ESP8266
	    timeClient.update();   // Опрос NTP-сервера
	    
	    Hours = timeClient.getHours();       // Получение текущего часа
	    Minutes = timeClient.getMinutes();   // Получение текущей минуты
	    Seconds = timeClient.getSeconds();   // Получение текущей секунды
	#else
	/* Если модель исполняется не на целевом устройстве,
	а в Engee, формируются следующие выходные значения: */
	
	if(Hours==23 && Minutes==59 && Seconds==59){ // Сброс часов, минут, секунд
	    Hours = 0;
	    Minutes = 0;
	    Seconds = 0;
	}
	if(Minutes==59 && Seconds==59){              // Сброс минут, секунд, инкремент часов
	    Hours++;
	    Minutes = 0;
	    Seconds = 0;
	}
	if(Seconds==59){                             // Сброс секунд, инкремент минут
	    Minutes++;
	    Seconds = 0;
	}
	Seconds++;                                   // Инкремент секунд
	#endif
	cfunc_symbols->Hours = Hours;
	cfunc_symbols->Minutes = Minutes;
	cfunc_symbols->Seconds = Seconds;
}

static void NTP_Client_cfunc_term() {
	/* Этот код вызывается один раз при остановке модели */
}
typedef struct WiFiConnect_cfunc_symbols_t {
	int64_t ResponseTime;
} WiFiConnect_cfunc_symbols_t;

typedef struct WiFiConnect_cfunc_params_t {
	bool _;
} WiFiConnect_cfunc_params_t;

WiFiConnect_cfunc_params_t WiFiConnect_cfunc_params = {
	false
};

static void WiFiConnect_cfunc_init() {

}
static void WiFiConnect_cfunc(WiFiConnect_cfunc_symbols_t * cfunc_symbols, WiFiConnect_cfunc_params_t * cfunc_params) {
	int64_t ResponseTime = cfunc_symbols->ResponseTime;
	#ifdef ESP8266
	  for(InitFlag1; InitFlag1 < 1; InitFlag1++){    // Инициализация внутри циклической функции
	    delay(2000);
	    Serial.println();
	    WiFi.begin(WIFI_SSID, WIFI_PASS);         // подключение к WiFi
	    while (WiFi.status() != WL_CONNECTED) {   // ожидание подключения к WiFi
	      delay(500);
	      Serial.print(".");
	      if (millis() > ResponseTime) ESP.restart();   // переподключение к WiFi
	      }
	    Serial.println("Connected");    // успешное подключение к WiFi
	  }
	#endif

}

static void WiFiConnect_cfunc_term() {

}
typedef struct ToSerial_cfunc_symbols_t {
	const int16_t *time;
} ToSerial_cfunc_symbols_t;

typedef struct ToSerial_cfunc_params_t {
	bool _;
} ToSerial_cfunc_params_t;

ToSerial_cfunc_params_t ToSerial_cfunc_params = {
	false
};

static void ToSerial_cfunc_init() {
	#ifdef ESP8266
	    // Инициализация последовательного порта со скоростью передачи 115 200 бод
	    Serial.begin(115200);
	#endif
}
static void ToSerial_cfunc(ToSerial_cfunc_symbols_t * cfunc_symbols, ToSerial_cfunc_params_t * cfunc_params) {
	const int16_t *time = cfunc_symbols->time;
	#ifdef ESP8266
	    if(time[3]==1) Serial.print("Розетка включена. ");  // Сообщение о включении розетки
	    else Serial.print("Розетка выключена. ");           // Сообщение о выключении розетки
	    
	    Serial.print("Время: ");
	    Serial.print(time[0]);  // Сообщение о текущем времени - час
	    Serial.print(":");
	    Serial.print(time[1]);  // Сообщение о текущем времени - минута
	    Serial.print(":");
	    Serial.println(time[2]);// Сообщение о текущем времени - секунда
	#endif

}

static void ToSerial_cfunc_term() {

}
typedef struct GPIO4_cfunc_symbols_t {
	double OutputState;
} GPIO4_cfunc_symbols_t;

typedef struct GPIO4_cfunc_params_t {
	bool _;
} GPIO4_cfunc_params_t;

GPIO4_cfunc_params_t GPIO4_cfunc_params = {
	false
};

static void GPIO4_cfunc_init() {
	#ifdef ESP8266
	    pinMode(PIN_NUMBER, OUTPUT); // Режим работы GPIO №"PIN_NUMBER" - выход
	#endif
}
static void GPIO4_cfunc(GPIO4_cfunc_symbols_t * cfunc_symbols, GPIO4_cfunc_params_t * cfunc_params) {
	double OutputState = cfunc_symbols->OutputState;
	#ifdef ESP8266
	      digitalWrite(PIN_NUMBER, OutputState); // Состояние GPIO №"PIN_NUMBER" - "OutputState"
	#endif
}

static void GPIO4_cfunc_term() {

}
/* SET_HIGH_1 reset function */
void SET_HIGH_1_reset() {
	SET_HIGH_1_Y.HIGH_LEV = 0.0;
	/* InitializeConditions for UnitDelay: /SET_HIGH/Unit Delay */
	SET_HIGH_1_S.UnitDelay_state = 0.0;
}

/* SET_HIGH_1 initialize function */
static void SET_HIGH_1_init() {
	SET_HIGH_1_Y.HIGH_LEV = 0.0;
	/* InitializeConditions for UnitDelay: /SET_HIGH/Unit Delay */
	SET_HIGH_1_S.UnitDelay_state = 0.0;
}

/* SET_HIGH_1 terminate function */
static void SET_HIGH_1_term() {
	/* (no terminate code required) */
}

/* SET_HIGH_1 step function */
static void SET_HIGH_1_step() {
	bool UnitDelay;
	bool RelationalOperator;

	if (esp8266_smart_socket_S.Check_time_state == 1) {
	if (esp8266_smart_socket_S.Check_time_state != esp8266_smart_socket_S.Check_time_prev) {
		SET_HIGH_1_reset();
	}
	/* Output for UnitDelay: /SET_HIGH/Unit Delay */
	UnitDelay = SET_HIGH_1_S.UnitDelay_state;
	/* RelationalOperator: /SET_HIGH/Relational Operator incorporates:
	 *  Constant: /SET_HIGH/Constant
	 *  UnitDelay: /SET_HIGH/Unit Delay
	 */
	RelationalOperator = 1.0 != UnitDelay;
	/* Outport: /SET_HIGH/HIGH_LEV incorporates:
	 *  RelationalOperator: /SET_HIGH/Relational Operator
	 */
	SET_HIGH_1_Y.HIGH_LEV = RelationalOperator;
	/* Update for UnitDelay: /SET_HIGH/Unit Delay */
	SET_HIGH_1_S.UnitDelay_state = RelationalOperator;

	}
}

/* Model initialize function */
void esp8266_smart_socket_init() {
	NTP_Client_cfunc_init();
	WiFiConnect_cfunc_init();
	esp8266_smart_socket_S.Check_time_state = 0;
	esp8266_smart_socket_S.Check_time_prev = 0;
	SET_HIGH_1_init();
	/* InitializeConditions for UnitDelay: /Unit Delay */
	esp8266_smart_socket_S.UnitDelay_state = 0.0;
	ToSerial_cfunc_init();
	GPIO4_cfunc_init();
}

/* Model terminate function */
void esp8266_smart_socket_term() {
	NTP_Client_cfunc_term();
	WiFiConnect_cfunc_term();
	SET_HIGH_1_term();
	ToSerial_cfunc_term();
	GPIO4_cfunc_term();
}

/* Model step function */
void esp8266_smart_socket_step() {
	int16_t Check_time;
	bool UnitDelay;
	bool RelationalOperator;
	static int16_t VectorConcatenate[4];
	double DataTypeConversion;

	/* Output for UnitDelay: /Unit Delay */
	UnitDelay = esp8266_smart_socket_S.UnitDelay_state;
	/* CFunction: /NTP_Client incorporates:
	 */
	NTP_Client_cfunc_symbols_t NTP_Client_cfunc_symbols = {
	};
	NTP_Client_cfunc(&NTP_Client_cfunc_symbols, &NTP_Client_cfunc_params);
	/* CFunction: /WiFiConnect incorporates:
	 *  Constant: /ResponseTime
	 */
	WiFiConnect_cfunc_symbols_t WiFiConnect_cfunc_symbols = {
		15000,
	};
	WiFiConnect_cfunc(&WiFiConnect_cfunc_symbols, &WiFiConnect_cfunc_params);
	esp8266_smart_socket_S.Check_time_prev = esp8266_smart_socket_S.Check_time_state;
	Check_time = 0;
	if (NTP_Client_cfunc_symbols.Hours == 15) {
		Check_time = 1;
	}
	esp8266_smart_socket_S.Check_time_state = Check_time;
	SET_HIGH_1_U.ActionPort = Check_time;
	/* Outputs for Atomic SubSystem: /SET_HIGH */
	SET_HIGH_1_step();
	/* End of Outputs for Atomic SubSystem: /SET_HIGH */
	/* RelationalOperator: /Relational Operator incorporates:
	 *  Outport: /SET_HIGH/HIGH_LEV
	 *  UnitDelay: /Unit Delay
	 */
	RelationalOperator = SET_HIGH_1_Y.HIGH_LEV != UnitDelay;
	/* Concatenate: /Vector Concatenate incorporates:
	 *  CFunction: /NTP_Client
	 *  CFunction: /NTP_Client
	 *  CFunction: /NTP_Client
	 *  RelationalOperator: /Relational Operator
	 */
	VectorConcatenate[0] = NTP_Client_cfunc_symbols.Hours;
	VectorConcatenate[1] = NTP_Client_cfunc_symbols.Minutes;
	VectorConcatenate[2] = NTP_Client_cfunc_symbols.Seconds;
	VectorConcatenate[3] = RelationalOperator;
	/* DataTypeConversion: /Data Type Conversion incorporates:
	 *  RelationalOperator: /Relational Operator
	 */
	DataTypeConversion = (double)RelationalOperator;
	/* CFunction: /ToSerial incorporates:
	 *  Concatenate: /Vector Concatenate
	 */
	ToSerial_cfunc_symbols_t ToSerial_cfunc_symbols = {
		VectorConcatenate,
	};
	ToSerial_cfunc(&ToSerial_cfunc_symbols, &ToSerial_cfunc_params);
	/* CFunction: /GPIO4 incorporates:
	 *  DataTypeConversion: /Data Type Conversion
	 */
	GPIO4_cfunc_symbols_t GPIO4_cfunc_symbols = {
		DataTypeConversion,
	};
	GPIO4_cfunc(&GPIO4_cfunc_symbols, &GPIO4_cfunc_params);
	/* Update for UnitDelay: /Unit Delay */
	esp8266_smart_socket_S.UnitDelay_state = SET_HIGH_1_Y.HIGH_LEV;

}
